<!DOCTYPE html>
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <title>Distortion Effect</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link href="https://fonts.googleapis.com/css2?family=Lobster&display=swap" rel="stylesheet">
        <link rel="stylesheet" href="css/effect.css" async defer>

    <!-- efeito 1 -->
        <script src="./js/jquery.min.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/animejs/3.2.0/anime.min.js" integrity="sha512-LfB+BcvR3zBt7ebVskhSWiSbEUiG3p5EcCprkieldsKhBeR6wpnLi0VpWC2GNgVGWP2n/skO8Bx2oKNjUhXCkw==" crossorigin="anonymous"></script>
    
    </head>
    <body>      
        
        <header>
            <h1>SVG Filters + Anime.js</h1>
        </header>

        <div class="container gallery">
                   
            <img class="el" draggable="false" src="assets/image.jpg" alt="Fota">
            
            <div class="container button-group">
         
            <button class="button extrusion primary">On</button>
          
            <button class="button extrusion secondary">Off</button>
       
        </div>

        </div>

        <div class="container gallery">
            
            <img class="el" draggable="false" src="assets/image-2.jpg"alt="Fota">
            
            <div class="container button-group">
            
                <button class="button extrusion primary">On</button>
            
                <button class="button extrusion secondary">Off</button>
        
            </div>
            
        </div>
        
        <svg class="defs" xmlns="http://www.w3.org/2000/svg" version="1.1">
            <defs>
                <filter id="distortion" width="3" height="20">
                    <feTurbulence id="turbulence" baseFrequency="0.00" numOctaves="1" result="warp"></feTurbulence>
                    <feOffset dx="-50" dy="-50" in="turbulence" result="warpOffset"></feOffset>
                    <feDisplacementMap xChannelSelector="R" yChannelSelector="G" scale="0" in2="warpOffset" in="SourceGraphic" />
                </filter>
            </defs>
        </svg>


        <script>

        var el = $(".el")
            element1 = $('.el').first()
            element2 = $('.el').last()
            buttonOn1 = $('.gallery:nth-of-type(1) .button.primary')
            buttonOff1 = $('.gallery:nth-of-type(1) .button.secondary')
            buttonOn2 = $('.gallery:nth-of-type(2) .button.primary')
            buttonOff2 = $('.gallery:nth-of-type(2) .button.secondary')
            effectDuration = 20000
            reverseDuration = 200

        

        // Distortion1 Timeline
        const distortion1 = anime.timeline({
            loop: false,
            autoplay: false,
        });
        
        // Undistortion1 Timeline
        const undistortion1 = anime.timeline({
            loop: false,
            autoplay: false,
        });
        

        // Distortion1 Animation
        const effect1 = {
            targets: ['#distortion feTurbulence','#distortion feDisplacementMap','#distortion feOffset'],
            autoplay: false,
            easing: 'linear',
            baseFrequency: [
                { value: 0.004, duration: 10, delay: 0 },
                { value: 0.004, duration: effectDuration-20, delay: 0 },
                { value: 0, duration: 10, delay: 0 },
            ],
            scale: [
                { value: 20, duration: 10, delay: 0 },
                { value: 20, duration: effectDuration-20, delay: 0 },
                { value: 0, duration: 10, delay: 0 }
            ],
            dy: [
                { value: -2000, duration: effectDuration , delay: 0 }
            ],
            complete: function() { 
        
                console.log("distortion over") 
            }
        };
        // Distortion1 Reverse Animation
        const reverseEffect1 = {
            targets: ['#distortion feTurbulence','#distortion feDisplacementMap','#distortion feOffset'],
            autoplay: false,
            easing: 'linear',
            duration: reverseDuration,
            baseFrequency: [ 0.014, 0 ],
            scale: [ 10, 0 ],
            complete: function() { 
        
                console.log("distortion over") 
            }
        };

        // Distortion2 Timeline
        const distortion2 = anime.timeline({
            loop: false,
            autoplay: false,
        });

        // Undistortion2 Timeline
        const undistortion2 = anime.timeline({
            loop: false,
            autoplay: false,
        });

         // Distortion2 Animation
         const effect2 = {
            targets: ['#distortion feTurbulence','#distortion feDisplacementMap'],
            autoplay: false,
            easing: 'linear',
            baseFrequency: [
                { value: 0.04, duration: 10, delay: 0 },
                { value: 0, duration: effectDuration-10, delay: 0 }
            ],
            scale: [
                { value: 20, duration: 10, delay: 0 },
                { value: 0, duration: effectDuration-10, delay: 0 }
            ]
        };
         
         // Undistortion2 Animation
         const reverseEffect2 = {
            targets: ['#distortion feTurbulence','#distortion feDisplacementMap'],
            autoplay: false,
            easing: 'linear',
            duration: reverseDuration,
            baseFrequency: [ 0.009, 0 ],
            scale: [ 10, 0 ]
        };


        // Distortion1 Timeline
        distortion1.add(effect1)
        // Undistortion1 Timeline
        undistortion1.add(reverseEffect1)
        // Distortion2 Timeline
        distortion2.add(effect2)
        // Undistortion2 Timeline
        undistortion2.add(reverseEffect2)


        // Function: Distort1
        const distort1 = () => {
            distortion1.play()
        }
        // Function: Stop Distort1
        const stopDistort1 = () => { 
            distortion1.restart()
            distortion1.pause()
            undistortion1.play()
        }
        // Function: Distort2
        const distort2 = () => { 
            distortion2.play()
        }
        // Function: Stop Distort2
        const stopDistort2 = () => { 
            distortion2.restart()
            distortion2.pause()
            undistortion2.play()
        }

        
        
        // Click Triggers
        element1.mousedown(distort1)

        element1.mouseup(stopDistort1)
        
        element2.mousedown(distort2)
        
        element2.mouseup(stopDistort2)

        el.mousedown(function() {
            $( this ).addClass("distorted")
            $( this ).addClass("position-correct")
        })

        el.mouseup(function() { 
            $( this ).removeClass("position-correct")
            setTimeout(() => {
                $( this ).removeClass("distorted")             
            }, reverseDuration);
        })


        // Controls
        buttonOn1.click(function() { 
            element1.addClass("distorted")
            element1.addClass("position-correct")
            distortion1.play()
        })

        buttonOff1.click(function() { 
            setTimeout(() => {
                element1.removeClass("distorted")             
            }, reverseDuration);
            element1.removeClass("position-correct")
            distortion1.restart()
            distortion1.pause() 
            undistortion1.play()
        })
        
        buttonOn2.click(function() { 
            element2.addClass("distorted")
            element2.addClass("position-correct") 
            distortion2.play()
        })

        buttonOff2.click(function() {
            setTimeout(() => {
                element2.removeClass("distorted")             
            }, reverseDuration);
            element2.removeClass("position-correct") 
            distortion2.restart()
            distortion2.pause()
            undistortion2.play()
        })





        </script>




    </body>
</html>